<?php
/*
Plugin Name: Attachement Disable Comments
Plugin URI: http://iworks.pl/
Description: Disable Comments on Attachement Page.
Author: Marcin Pietrzak
Version: 1.0
Author URI: http://iworks.pl/
*/

class iworks_attachements_close_comments {

	public function __construct() {
		add_action( 'comments_open', array( $this, 'close_comments' ), PHP_INT_MAX, 2 );
		add_action( 'comment_form_comments_closed', array( $this, 'message' ) );
	}

	public function close_comments( $open, $post_id ) {
		$post = get_post( $post_id );
		if (
			is_object( $post )
			&& isset( $post->post_type )
			&& 'attachment' === $post->post_type
		) {
			$open = false;
		}
		return $open;
	}
}
new iworks_attachements_close_comments();
